﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace DockSample
{
    public class BrakeResistor : GenericStaticComponent, IAccessory
    {        
        private double _resistance;
        private double _maxPwr;
        private double _maxPwrDur;
        private double _pwrED;
        private double _nomPwr;

        //Constructor
        public BrakeResistor()
        {
            _mainType = MainType.BrakeResistor;
        }

        [Category("Regenerative"), Description("Resistance in ohms (Ω).")]
        public double Resistance
        {
            get { return _resistance; }
            set
            {
                if (value != this._resistance)
                {
                    this._resistance = value;
                    OnPropertyChanged("Resistance");
                }
            }
        }


        [Category("Regenerative"), Description("Maximum brake power in watts (W).")]
        public double MaxPwr
        {
            get { return _maxPwr; }
            set
            {
                if (value != this._maxPwr)
                {
                    this._maxPwr = value;
                    OnPropertyChanged("MaxPwr");
                }
            }
        }

        [Category("Regenerative"), Description("Maximum brake time in seconds (s) at maximum current.")]
        public double MaxPwrDur
        {
            get { return _maxPwrDur; }
            set
            {
                if (value != this._maxPwrDur)
                {
                    this._maxPwrDur = value;
                    OnPropertyChanged("MaxPwrDur");
                }
            }
        }

        [Category("Regenerative"), Description("Maximum brake time in seconds (s) at maximum current.")]
        public double PwrED
        {
            get { return _pwrED; }
            set
            {
                if (value != this._pwrED)
                {
                    this._pwrED = value;
                    OnPropertyChanged("PwrED");
                }
            }
        }

        [Category("Regenerative"), ReadOnly(true), Description("Nominal brake power in watts (W).")]
        public double NomPwr
        {
            get { return _nomPwr; }
            set
            {
                if (value != this._nomPwr)
                {
                    this._nomPwr = value;
                    OnPropertyChanged("NomPwr");
                }
            }
        }
    }
}
