﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace DockSample
{
    public class BrakeUnit : GenericStaticComponent
    {
        //Brake unit data
        protected double _maxTransCur;
        protected double _maxTransDur;
        protected double _transED;
        protected double _nomTransCur;
        protected double _brkDCVlt;
        protected double _minBrkRes;

        //Constructor
        public BrakeUnit(string name)
        {
            _name = name;
            _mainType = MainType.BrakeUnit;
        }

        public double MaxTransCur
        {
            get { return _maxTransCur; }
            set
            {
                if (value != this._maxTransCur)
                {
                    this._maxTransCur = value;
                    OnPropertyChanged("MaxTransCur");
                }
            }
        }

        public double MaxTransDur
        {
            get { return _maxTransDur; }
            set
            {
                if (value != this._maxTransDur)
                {
                    this._maxTransDur = value;
                    OnPropertyChanged("MaxTransDur");
                }
            }
        }

        public double TransED
        {
            get { return _transED; }
            set
            {
                if (value != this._transED)
                {
                    this._transED = value;
                    OnPropertyChanged("TransED");
                }
            }
        }

        public double NomTransCur
        {
            get { return _nomTransCur; }
            set
            {
                if (value != this._nomTransCur)
                {
                    this._nomTransCur = value;
                    OnPropertyChanged("NomTransCur");
                }
            }
        }

        public double BrkDCVolt
        {
            get { return _brkDCVlt; }
            set
            {
                if (value != this._brkDCVlt)
                {
                    this._brkDCVlt = value;
                    OnPropertyChanged("BrkDCVolt");
                }
            }
        }

        public double MinBrkRes
        {
            get { return _minBrkRes; }
            set
            {
                if (value != this._minBrkRes)
                {
                    this._minBrkRes = value;
                    OnPropertyChanged("MinBrkRes");
                }
            }
        }
    }
}
