﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DockSample
{
    public class Cable : GenericStaticComponent, IAccessory
    {
        //Unique properties
        private double _length;
        private ConnectionDirection _connectionDirection;
        private bool _flexible;
        private double _diameter;
        private double _minRadius;
        
        //Current data

        //Constructor
        public Cable(MainType mainType)
        {
            _mainType = mainType;
        }

        public double Length
        {
            get { return _length; }
            set
            {
                if (value != this._length)
                {
                    this._length = value;
                    if (!AutoSelect)
                        OnPropertyChanged("Length");
                }
            }
        }        
        
        public ConnectionDirection ConnectionDirection
        {
            get { return _connectionDirection; }
            set
            {
                if (value != this._connectionDirection)
                {
                    this._connectionDirection = value;
                    if (!AutoSelect)
                        OnPropertyChanged("_connectionDirection");
                }
            }
        }

        public bool Flexible
        {
            get { return _flexible; }
            set
            {
                if (value != this._flexible)
                {
                    this._flexible = value;
                    if (!AutoSelect)
                        OnPropertyChanged("Flexible");
                }
            }
        }

        public double Diameter
        {
            get { return _diameter; }
            set
            {
                if (value != this._diameter)
                {
                    this._diameter = value;
                    if (!AutoSelect)
                        OnPropertyChanged("Diameter");
                }
            }
        }

        public double MinRadius
        {
            get { return _minRadius; }
            set
            {
                if (value != this._minRadius)
                {
                    this._minRadius = value;
                    if (!AutoSelect)
                        OnPropertyChanged("MinRadius");
                }
            }
        }
    }
}
