﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DockSample
{
    public abstract class GenericMove : NotifyPropertyChangedBase
    {
        protected string _name;
        protected string _oldName;

        protected double _time;
        protected double _degrees;
        protected double _distance;

        protected double _initialSpeed;
        protected double _finalSpeed;

        protected double _averageAcc;
        protected double _averageSpeed;

        protected double _percentSineVel;
        protected double _percentSineAcc;

        public struct SectorOffset
        {
            public double timetoAdd;
            public double valuetoAdd;

            public SectorOffset(double remTime, double remValue)
            {
                timetoAdd = remTime;
                valuetoAdd = remValue;
            }
        };

        public string Name
        {
            get { return _name; }
            set
            {
                if (value != this._name)
                {
                    this._oldName = this._name;
                    this._name = value;
                    OnPropertyChanged("Name");
                }
            }
        }

        public string OldName
        {
            get { return _oldName; }
        }

        public double Time
        {
            get { return _time; }
            set
            {
                if (value != this._time)
                {
                    this._time = value;
                    OnPropertyChanged("Time");
                }
            }
        }

        public double Degrees
        {
            get { return _degrees; }
            set
            {
                if (value != this._degrees)
                {
                    this._degrees = value;
                    OnPropertyChanged("Degrees");
                }
            }
        }

        public double Distance
        {
            get { return _distance; }
            set
            {
                if (value != this._distance)
                {
                    this._distance = value;
                    OnPropertyChanged("Distance");
                }
            }
        }

        public double AverageAcc
        {
            get { return _averageAcc; }
            set
            {
                if (value != this._averageAcc)
                {
                    this._averageAcc = value;
                    OnPropertyChanged("AverageAcc");
                }
            }
        }

        public double AverageSpeed
        {
            get { return _averageSpeed; }
            set
            {
                if (value != this._averageSpeed)
                {
                    this._averageSpeed = value;
                    OnPropertyChanged("AverageSpeed");
                }
            }
        }

        public double InitialSpeed
        {
            get { return _initialSpeed; }
            set
            {
                if (value != this._initialSpeed)
                {
                    this._initialSpeed = value;
                    OnPropertyChanged("InitialSpeed");
                }
            }
        }

        public double FinalSpeed
        {
            get { return _finalSpeed; }
            set
            {
                if (value != this._finalSpeed)
                {
                    this._finalSpeed = value;
                    OnPropertyChanged("FinalSpeed");
                }
            }
        }

        public double PercentSineVel
        {
            get { return _percentSineVel; }
            set
            {
                if (value != this._percentSineVel)
                {
                    if (value > 100)
                        value = 100;
                    if (value < 1)
                        value = 1;

                    this._percentSineVel = value;
                    OnPropertyChanged("PercentSineVel");
                }
            }
        }

        public double PercentSineAcc
        {
            get { return _percentSineAcc; }
            set
            {
                if (value != this._percentSineAcc)
                {
                    if (value > 100)
                        value = 100;
                    if (value < 1)
                        value = 1;

                    this._percentSineAcc = value;
                    OnPropertyChanged("PercentSineAcc");
                }
            }
        }
    }
}
