﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace DockSample
{
    public class LoadMass : DetachableLoad
    {
        private double _mass;

        public LoadMass(string name)
        {
            _name = name;
            _mainType = MainType.Mass;
        }

        [Category("Main"), ReadOnly(false), Description("Moving (non rotating) mass in kilograms (kg).")]
        public double Mass
        {
            get { return _mass; }
            set
            {
                if (value != this._mass)
                {
                    this._mass = value;
                    OnPropertyChanged("Mass");
                }
            }
        }
    }
}
