﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace DockSample
{
    public class LoadTorque : DetachableLoad
    {
        protected double _torque;

        public LoadTorque(string name)
        {
            _name = name;
            _mainType = MainType.Torque;
        }

        [Category("Main"), ReadOnly(false), Description("Static torque in newton meters (Nm).")]
        public double Torque
        {
            get { return _torque; }
            set
            {
                if (value != this._torque)
                {
                    this._torque = value;
                    OnPropertyChanged("Torque");
                }
            }
        }
    }
}
