﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DockSample
{
    public class Moves : NotifyPropertyChangedBase
    {
        //private double _totalDistance;
        //private double _totalTime;

        private bool _refresh;

        private SortedList<int, Move> _movesList = new SortedList<int, Move>();

       // private LoadResult _totalLoadResults = new LoadResult();
        //private Motor _motor = new Motor();
        private MotorResult _motorResults = new MotorResult();
        private List<SectorElement> _activeSectorElementsList = new List<SectorElement>();
        private SortedList<int, LoadResult> _loadResultsList = new SortedList<int, LoadResult>();

        public Moves() { }

        public bool Refresh
        {
            get { return _refresh; }
            set
            {
                if (value != this._refresh)
                {
                    this._refresh = value;
                    OnPropertyChanged("Refresh");
                }
            }
        }

        public SortedList<int, Move> MovesList
        {
            get { return _movesList; }
        }

       /* public LoadResult TotalLoadResults
        {
            get { return _totalLoadResults; }
            set
            {
                _totalLoadResults = value;
                OnPropertyChanged("TotalLoadResults");
            }
        }*/

       /* public Motor Motor
        {
            get { return _motor; }
            set { _motor = value; }
        } */

        public MotorResult MotorResults
        {
            get { return _motorResults; }
            set
            {
                _motorResults = value;
            }
        }

        public SortedList<int, LoadResult> LoadResultsList
        {
            get { return _loadResultsList; }
        }

 //       public List<MoveResults> MoveResultsList
 //       {
  //          get { return _moveResultsList; }
  //      }

        public List<SectorElement> ActiveSectorElementsList
        {
            get { return _activeSectorElementsList; }
        }

        /*public double TotalDistance
        {
            get { return _totalDistance; }
            set
            {
                if (value != this._totalDistance)
                {
                    this._totalDistance = value;
                    OnPropertyChanged("TotalDistance");
                }
            }
        }

        public double TotalTime
        {
            get { return _totalTime; }
            set
            {
                if (value != this._totalTime)
                {
                    this._totalTime = value;
                    OnPropertyChanged("TotalTime");
                }
            }
        } */

        /*public void CalcMoveResults(List<Move> movesList)
        {
            //Clear the MoveResultsList
            MoveResultsList.Clear();

            //Collect LoadResults and Move-data into the MoveResultsList
            int count = 0;

            foreach (Move move in movesList)
            {
                MoveResultsList.Add(new MoveResults());

                MoveResultsList[count].ID = move.ID;
                MoveResultsList[count].Name = move.Name;
                MoveResultsList[count].Active = false;
                MoveResultsList[count].Distance = move.Distance;
                MoveResultsList[count].Time = move.Time;
                //MoveResultsList[count].AverageAcc = move.AverageAcc;
                MoveResultsList[count].Inertia = move.InitialSpeed;
                MoveResultsList[count].FinalSpeed = move.FinalSpeed;
                //MoveResultsList[count].PercentSineVel = move.PercentSineVel;
                //MoveResultsList[count].PercentSineAcc = move.PercentSineAcc;
                MoveResultsList[count].Gearing = move.LoadResults.Gearing;
                MoveResultsList[count].Inertia = move.LoadResults.Inertia;
                MoveResultsList[count].IdleTorque = move.LoadResults.IdleTorque;
                MoveResultsList[count].LoadTorque = move.LoadResults.LoadTorque;
                MoveResultsList[count].AccTorque = move.LoadResults.AccTorque;
                MoveResultsList[count].MovePerRev = move.LoadResults.MovePerRev;
                MoveResultsList[count].Efficiency = move.LoadResults.Efficiency;
                MoveResultsList[count].Speed = move.LoadResults.Speed;
                MoveResultsList[count].Backlash = move.LoadResults.Backlash;

                count++;
            }
        }*/

        public void AddAllMotionProfiles(SortedList<int, Move> movesList)
        {
            //Clear the MoveResultsList
            ActiveSectorElementsList.Clear();

            //Collect LoadResults and Move-data into the MoveResultsList
            double count = 1;
            double lastPosition = 0;

            foreach (var m in movesList)
            {
                Move move = m.Value;

                foreach (Sector s in move.SectorsList)
                {
                    foreach (SectorElement sE in s.SectorElementsList)
                    {
                        ActiveSectorElementsList.Add(new SectorElement(count, sE.Jerk, sE.Acc, sE.Vel, sE.Pos + lastPosition, sE.Torque, sE.MotorTorqueLimit, sE.RegenerativePower));

                        count++;
                    }

                    if (ActiveSectorElementsList.Count > 0)
                        lastPosition = ActiveSectorElementsList[ActiveSectorElementsList.Count - 1].Pos;
                }
            }
        }
    }
}