﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DockSample
{
    public class SectorElement : NotifyPropertyChangedBase
    {
        private double _time;
        private double _pos;
        private double _vel;
        private double _acc;
        private double _jerk;
        private double _torque; //Total load torque (with or without motor inertia included
        private double _motorTorqueLimit; //Motor limit due operation in speeds above the field weakening point
        private double _regenerativePower; //Regenerative power

        public SectorElement(double time, double jerk, double acc, double vel, double pos, double torque, double motorTorqueLimit, double regenerativePower)
        {
            _time = time;
            _pos = pos;
            _vel = vel;
            _acc = acc;
            _jerk = jerk;
            _torque = torque;
            _motorTorqueLimit = motorTorqueLimit;
            _regenerativePower = regenerativePower;
        }



        public double Time
        {
            get { return _time; }
            set
            {
                if (value != this._time)
                {
                    this._time = value;
                    OnPropertyChanged("Time");
                }
            }
        }

        public double Pos
        {
            get { return _pos; }
            set
            {
                if (value != this._pos)
                {
                    this._pos = value;
                    OnPropertyChanged("Pos");
                }
            }
        }

        public double Vel
        {
            get { return _vel; }
            set
            {
                if (value != this._vel)
                {
                    this._vel = value;
                    OnPropertyChanged("Vel");
                }
            }
        }

        public double Acc
        {
            get { return _acc; }
            set
            {
                if (value != this._acc)
                {
                    this._acc = value;
                    OnPropertyChanged("Acc");
                }
            }
        }

        public double Jerk
        {
            get { return _jerk; }
            set
            {
                if (value != this._jerk)
                {
                    this._jerk = value;
                    OnPropertyChanged("Jerk");
                }
            }
        }

        public double Torque
        {
            get { return _torque; }
            set
            {
                if (value != this._torque)
                {
                    this._torque = value;
                    OnPropertyChanged("Torque");
                }
            }
        }

        public double MotorTorqueLimit
        {
            get { return _motorTorqueLimit; }
            set
            {
                if (value != this._motorTorqueLimit)
                {
                    this._motorTorqueLimit = value;
                    OnPropertyChanged("MotorTorqueLimit");
                }
            }
        }

        public double RegenerativePower
        {
            get { return _regenerativePower; }
            set
            {
                if (value != this._regenerativePower)
                {
                    this._regenerativePower = value;
                    OnPropertyChanged("RegenerativePower");
                }
            }
        }
    }
}
