﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Drawing.Design;
using System.Windows.Forms;

namespace DockSample
{
    internal class UIInertiaEditor : UITypeEditor
    {
        private UIDialogDefineInertia inertiaDialog = new UIDialogDefineInertia();

        public override UITypeEditorEditStyle GetEditStyle(
         ITypeDescriptorContext context)
        {
            return UITypeEditorEditStyle.Modal;
        }

        public override object EditValue(
         ITypeDescriptorContext context,
         IServiceProvider provider,
         object value)
        {
            inertiaDialog.StartPosition = FormStartPosition.CenterParent;

            if (inertiaDialog.ShowDialog() == DialogResult.OK)
            {
                return inertiaDialog.Inertia;
            }

            return base.EditValue(context, provider, value);
        }
    } 
}
