﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DockSample
{
    public class AddInsertLoadEventArgs : EventArgs
    {
        private string _nodenName;
        private MainType _mainType;

        public AddInsertLoadEventArgs(string nodeName, MainType mainType)
        {
            _nodenName = nodeName;
            _mainType = mainType;
        }

        public string NodeName
        {
            get { return _nodenName; }
            set { _nodenName = value; }
        }

        public MainType MainType
        {
            get { return _mainType; }
            set { _mainType = value; }
        }
    }

    public class MoveRemoveLoadEventArgs : EventArgs
    {
        private string _nodeName;
        private MoveRemoveEvent _moveRemoveEvent; //Insert, MoveUp, MoveDown, Remove 

        public MoveRemoveLoadEventArgs(string nodeName, MoveRemoveEvent moveRemoveEvent)
        {
            _nodeName = nodeName;
            _moveRemoveEvent = moveRemoveEvent;
        }

        public string NodeName
        {
            get { return _nodeName; }
            set { _nodeName = value; }
        }

        public MoveRemoveEvent MoveRemoveEvent
        {
            get { return _moveRemoveEvent; }
            set { _moveRemoveEvent = value; }
        }
    }

    public class AddInsertMoveEventArgs : EventArgs
    {
        private string _nodeName;
        private MoveType _moveType; //

        public AddInsertMoveEventArgs(string nodeName, MoveType moveType)
        {
            _nodeName = nodeName;
            _moveType = moveType;
        }

        public string NodeName
        {
            get { return _nodeName; }
            set { _nodeName = value; }
        }

        public MoveType MoveType
        {
            get { return _moveType; }
            set { _moveType = value; }
        }
    }

    public class MoveRemoveMoveEventArgs : EventArgs
    {
        private string _nodeName;
        private MoveRemoveEvent _moveRemoveEvent; //Insert, MoveUp, MoveDown, Remove 

        public MoveRemoveMoveEventArgs(string nodeName, MoveRemoveEvent MoveRemoveEvent)
        {
            _nodeName = nodeName;
            _moveRemoveEvent = MoveRemoveEvent;
        }

        public string NodeName
        {
            get { return _nodeName; }
            set { _nodeName = value; }
        }

        public MoveRemoveEvent MoveRemoveEvent
        {
            get { return _moveRemoveEvent; }
            set { _moveRemoveEvent = value; }
        }
    }

    public class RefreshPropertyGridEventArgs : EventArgs
    {
        private bool _refreshPropertyGridEvent; //Refresh property grid after value update 

        public RefreshPropertyGridEventArgs() {}

        public bool RefreshPropertyGridEvent
        {
            get { return _refreshPropertyGridEvent; }
            set { _refreshPropertyGridEvent = value; }
        }
    }
}
