﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.OleDb;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace DockSample
{
    public partial class UIDialogReadArticles : Form
    {
        public MainType mainType = MainType.Undefined;
        public string ArticleNo;
 
        public UIDialogReadArticles() //MainType mainType) //, int articleNo)
        {
            InitializeComponent();
        }

        private void DialogReadArticles_Load(object sender, EventArgs e)
        {
            //Connect to the database
            string dbPath = Application.StartupPath + @"\Database\DriveSystems.mdb"; //Path.GetFullPath
                // (@"C:\DriveSystems.mdb");

            using (OleDbConnection dbDriveSystemsConn = new OleDbConnection(
                "Provider=Microsoft.Jet.OLEDB.4.0;" +
                "Data Source=" + dbPath + ";" +
                "Jet OLEDB:Database Password=BBSD"))
            {
                using (dbDriveSystemsDataClassesDataContext dbDriveSystemsContext =
                  new dbDriveSystemsDataClassesDataContext(dbDriveSystemsConn))
                // using (DriveSystemsDataSet dBDriveDataSet = new DriveSystemsDataSet())
                {

                    switch (mainType)
                    {
                        case (MainType.GearBox):

                            //Read the data from the Motors table
                            var qryGearBoxes =
                                from tblGearBoxes myArticles in dbDriveSystemsContext.tblGearBoxes
                                orderby myArticles.Price, myArticles.NomTrq
                                select myArticles;

                            dataGridView_ArticleData.AutoGenerateColumns = true;
                            dataGridView_ArticleData.DataSource = qryGearBoxes;
                            break;

                        default:

                            //Read the data from the Motors table
                            var qryMotors =
                                from tblMotors myMotors in dbDriveSystemsContext.tblMotors
                                orderby myMotors.Price, myMotors.NomTrq
                                select myMotors;

                            dataGridView_ArticleData.AutoGenerateColumns = true;
                            dataGridView_ArticleData.DataSource = qryMotors;
                            break;
                    }

                    dataGridView_ArticleData.CurrentCell = dataGridView_ArticleData.Rows[0].Cells[0];

                    dataGridView_ArticleData.CurrentRow.Selected = false;
                    dataGridView_ArticleData.Rows[0].Selected = true;

                    ArticleNo = dataGridView_ArticleData.Rows[0].Cells[0].Value.ToString();
                }
            }
        }

        private void button_OK_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.OK;
            Close();
        }

        private void button_Cancel_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
            Close();
        }

        private void dataGridView_ArticleData_SelectionChanged(object sender, EventArgs e)
        {           
            if (dataGridView_ArticleData.CurrentRow != null)
            ArticleNo = dataGridView_ArticleData.CurrentRow.Cells[0].Value.ToString();
        }
    }
}
